      Program Iran2SMC

* SPECIAL PURPOSE FOR IRAN DATA

* Reformat into a smc file an ascii file in which there are possible comments 
* preceeded by "!" or "|", followed by one header line, followed by the data
* in two columns: time, data

* Note: to use, first make three txt files of data, with the npts as the first
* line.  Later I will modify this to read the original input files (Kinemetric
* format?)

* Sample control file:
* first line below starts the control, with line 1, col 1 = "N" in "Nominal":
*Control file for Asc2SMC      ! first line
*Name of summary file:
* asc2smc.sum
*Headers?
*  Y
*Xfactr
* 1.0
*Input file name ("stop" in any column to quit):
* \smsim\ts0.col
* \smsim\ts1.col
*STOP

* Dates: 05/01/02 - Written by D. Boore, patterned after col2smc
*        05/16/02 - Add header comments to smc file
*        11/01/03 - Prepare for LF95 (account for longer file names) by using
*                   trim_c.
*                   Add line to ctl indicating if there are any header lines
*        11/03/03 - Add variable "xfactr" to allow multiplicative factor 
*                   (can be used to change the units or the sign of the 
*                   time series values)
*        11/04/03 - Corrected bug (skipped first data value if file has headers)
*        11/13/03 - Allow for long input file names with several periods
*                   by looking for last period and replacing the portion
*                   from there to the end with ".smc"
*        01/18/05 - Modified for \forprogs\asc2smc for BAM data
*        10/17/07 - Transparent change to user needed because smcread can
*                   read two input formats

      character precision*8
      
      real time(100000), ts(100000)
      character f_ctl*40, f_sum*40, f_asc*40, f_smc*40, f_asc_4*4
      character char_head(11)*80, comments(100)*80, hdr_cmmnts(100)*79
      character headers_query*10
      integer int_head(48)
      real real_head(50)

      logical f_ctl_exist

      do i = 2, 11
        char_head(i) = '*'
      end do

      int_null = -32768
      do i = 1, 48
        int_head(i) = int_null
      end do
*      int_head(13) = 0
*      int_head(14) = 0

      real_null = 1.7e+38
      do i = 1, 50
        real_head(i) = real_null
      end do

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr = iran2smc.ctl): '
        read(*, '(a)') f_ctl
        if (f_ctl(1:4) .eq. '    ') f_ctl = 'iran2smc.ctl'
        call trim_c(f_ctl, nc_f_ctl)
        inquire(file=f_ctl(1:nc_f_ctl), exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do
      call get_lun(nu_ctl)
      open(unit=nu_ctl, file=f_ctl(1:nc_f_ctl), status='unknown')

      call skip(nu_ctl,2)
      f_sum = ' '
      read(nu_ctl,'(a)') f_sum
      call trim_c(f_sum, nc_f_sum)
      call get_lun(nu_sum)
      open(unit=nu_sum, file=f_sum(1:nc_f_sum), status='unknown')
      write(nu_sum,'(a)') '  Summary program for program ASC2SMC'      

      call skip(nu_ctl,1)
      headers_query = ' '
      read(nu_ctl,'(a)') headers_query
      call upstr(headers_query)
      call trim_c(headers_query, nc_headers_query)

      call skip(nu_ctl,1)
      read(nu_ctl,*) xfactr

      call skip(nu_ctl,1)

1234  continue

      f_asc = ' '
      read(nu_ctl,'(a)') f_asc
      call trim_c(f_asc,nc_f_asc)
      f_asc_4 = ' '
      f_asc_4 = f_asc(1:4)
      call upstr(f_asc_4)
      if(f_asc_4 .eq. 'STOP') go to 4321
      write(nu_sum,'(2a)') '  Processing file: ', f_asc(1:nc_f_asc)

      call get_lun(nu_asc)
      open(unit=nu_asc, file=f_asc(1:nc_f_asc), status='unknown')

      if (headers_query(1:1) .eq. 'Y') then
        call skipcmnt(nu_asc, hdr_cmmnts, n_hdr_cmmnts)
*        call skip(nu_asc,1)
      end if



*      n_ts = 0
*222   continue
*      read(nu_asc,*,end=333) time(n_ts+1), ts(n_ts+1)
*      n_ts = n_ts + 1
*      go to 222
*333   continue 

       read(nu_asc,*) n_ts
       read(nu_asc,'(10e13.6)') (ts(i), i=1,n_ts)
       sps = 200
       do i = 1, n_ts
         time(i) = float(i-1)/sps
       end do

* Scale the time series:
      do i = 1, n_ts
        ts(i) = xfactr * ts(i)
      end do

* Get dt:

*      dt = time(2) - time(1)    
*      sps = 1.0/dt
       dt = 1.0/sps

      write(nu_sum,'(a,1x,i6,1x,f7.2)') '    n_ts, sps = ', n_ts, sps

      int_head(17) = n_ts
      
      real_head(2) = sps

      call skipcmnt(nu_asc, hdr_cmmnts, n_hdr_cmmnts)

      ncomments = 0
      ncomments = ncomments + 1
      comments(ncomments) = '|'
      do i = 1, n_hdr_cmmnts
        ncomments = ncomments + 1
        comments(ncomments) = '|'//hdr_cmmnts(i)
      end do
      ncomments = ncomments + 1
      comments(ncomments) = '|'
      ncomments = ncomments + 1
      comments(ncomments) = '| File '//f_asc(1:nc_f_asc)//
     : ' reformatted by program ASC2SMC'
      ncomments = ncomments + 1
      comments(ncomments) = '| Data values scaled by the factor '
      call trim_c(comments(ncomments), nc_c)
      write(comments(ncomments)(nc_c+1:nc_c+11),'(0p,1x,e10.3)')
     :  xfactr
      ncomments = ncomments + 1
      comments(ncomments) = '|'

      int_head(16) = ncomments

      f_smc = ' '
* Find last period:
      do i = nc_f_asc, 1, -1
        if (f_asc(i:i) .eq. '.') then
          indexp = i
          go to 456
        end if
      end do
      indexp = 1
456   continue
      f_smc = f_asc(1:indexp)//'smc'
      call trim_c(f_smc,nc_f_smc)

      write(*,'(a)') ' Writing file '//f_smc(1:nc_f_smc)

      precision = ' '
      precision = 'STANDARD'
      int_head(47) = int_head(1)

      call smcwrite(f_smc, precision,
     :              ts, char_head, 0, 
     :              int_head, real_head, comments)

      go to 1234

4321  continue

      close(nu_ctl)
      close(nu_sum)

      stop
      end

      include '\forprogs\skip.for'
      include '\forprogs\smcwrite.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\upstr.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\mnmaxidx.for'
      include '\forprogs\skipcmnt.for'
