* ------------------------------------------------------------- SXV2SMC
      Program SXV2SMC

* Reformats Spudich and Xu Compsyn files into smc

* Barebones program:

* Dates: 08/11/02 - Written by D. Boore
*        10/17/07 - Transparent change to user needed because smcread can
*                   read two input formats

      character precision*8
      

      character f_ctl*80, f_in*80, f_smc*80
      character buf*80, buf_upper*4

      character char_head(11)*80, comments(400)*80,
     : date_c*8, time_c*11, ctl_comments(20)*80

      integer int_head(48)
      real real_head(50)

      real y(:)
      allocatable :: y


      logical f_ctl_exist, f_in_exist

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr = sxv2smc.ctl): '
        read(*, '(a)') f_ctl
        if (f_ctl(1:4) .eq. '    ') f_ctl = 'sxv2smc.ctl'
        inquire(file=f_ctl, exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do
      call get_lun(nu_ctl)
      open(unit=nu_ctl, file=f_ctl, status='unknown')


      call skipcmnt(nu_ctl, ctl_comments, nc_ctl_c)

1000  continue
      buf = ' '
      read(nu_ctl,'(a)',end = 9999) buf
      call trim_c(buf,nc_buf)
      buf_upper = ' '
      buf_upper = buf(1:4)
      call upstr(buf_upper)
      if(nc_buf .eq. 0 .or. buf(1:1) .eq. '!') go to 1000
      if(buf_upper(1:4) .eq. 'STOP') goto 9999

      f_in = ' '
      f_in = buf(1:nc_buf)
      call trim_c(f_in,nc_f_in)
      inquire(file=f_in(1:nc_f_in), exist=f_in_exist)
      if (.not. f_in_exist) then
          write(*,'(a)') ' ****** FILE '//f_in(1:nc_f_in)// 
     :          ' DOES NOT EXIST; SKIPPING!!! ******* '
          go to 1000
      end if


      iflag = 0
      call datetime(date_c, time_c, iflag)


      call get_lun(nu_in)

      open(unit=nu_in,file=f_in,status='unknown')

      read(nu_in,*) amaxhed
      maxhed = amaxhed

      call skip(nu_in, 4)

      read(nu_in,*) dt
      sps = 1.0/dt

      read(nu_in,*) ant
      npts = ant

      allocate (y(npts))

      read(nu_in,*) rdv
      idv = rdv

      call skip(nu_in, maxhed-8)

      do i_ts = 1, npts
        read(nu_in,*) y(i_ts)
      end do

      close(nu_in)
  

        do i = 1, 11
          char_head(i) = '*'
        end do

        inull = -32768
        do i = 1, 48
          int_head(i) = inull
        end do
        int_head(17) = npts

        rnull = 1.7e38
        do i = 1, 50
          real_head(i) = rnull
        end do
        real_head(2) = sps

        ncomments = 1
        comments(ncomments) = '|'
        ncomments = ncomments + 1
        comments(ncomments) = 
     :     '|  Program SXV2SMC reformatted input file: '//
     :         f_in(1:nc_f_in)
        ncomments = ncomments + 1
        comments(ncomments) = '|  on '//date_c//' at time '//time_c
        ncomments = ncomments + 1
        comments(ncomments) = '|'
        int_head(16) = ncomments 

        if (idv .eq. 0) then
           i_type = 4
        else
           i_type = 3
        end if

        f_smc = ' '
        f_smc = f_in(1:nc_f_in)//'C'

      precision = ' '
      precision = 'STANDARD'
      int_head(47) = int_head(1)

        call SMCWrite(f_smc, precision,
     :               y, char_head, i_type, 
     :                    int_head, real_head, comments)

        deallocate (y)

        go to 1000

9999  continue
        close(nu_ctl)
        stop
      


      end
* ------------------------------------------------------------- ImpC2SMC

      include '\forprogs\skip.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\upstr.for'
      include '\forprogs\mnmaxidx.for'
      include '\forprogs\datetime.for'
      include '\forprogs\smcwrite.for'
      include '\forprogs\skipcmnt.for'

      